using System;
using NUnit.Framework; // [1]
using NUnit.Framework.SyntaxHelpers; // [2]

namespace NUnitDemo
{
    [TestFixture] // [3]
    public class CounterTest : AssertionHelper // [4]
    {
        private Counter counter;

        [SetUp] // [5]
        public void setUp()
        {
            counter = new Counter();
        }

        [TearDown] // [6]
        public void tearDown()
        { 
        }


        [Test] // [7]
        public void test_init()
        {
            Expect(counter.get(), EqualTo(0)); // [8]
        }

        [Test] // [7]
        public void test_incr()
        {
            for (int i = 1; i < 10; ++i)
            {
                counter.incr();
                Expect(counter.get(), EqualTo(i)); // [8]
            }
        }

        [Test] // [7]
        public void test_clear()
        {
            counter.incr();
            counter.incr();
            counter.clear();
            Expect(counter.get(), Is.EqualTo(0)); // [8]
        }

    }
}
