#include "tokenizer.h"

tokenizer::tokenizer(const std::string& delim)
  : delim_(delim) {}

void tokenizer::start(const std::string& source) {
  source_ = source;
  reset();
}

void tokenizer::reset() {
  range_.first = 0;
  range_.second = 0;
}

bool tokenizer::next() {
  range_.first = source_.find_first_not_of(delim_, range_.first + range_.second);
  if ( range_.first == std::string::npos ) {
    return false;
  }
  range_.second = source_.find_first_of(delim_, range_.first);
  if ( range_.second == std::string::npos ) {
    range_.second = source_.size() - range_.first;
    return true;
  }
  range_.second -= range_.first;
  return true;
}

std::string tokenizer::token() const {
  return source_.substr(range_.first, range_.second);
}

tokenizer::range_type tokenizer::range() const {
  return range_;
}
